org.apache.solr.spelling

## Class PossibilityIterator

- java.lang.Object
- - org.apache.solr.spelling.PossibilityIterator

- All Implemented Interfaces:
    Iterator<PossibilityIterator.RankedSpellPossibility>

      public class PossibilityIterator
      extends Object
      implements Iterator<PossibilityIterator.RankedSpellPossibility>

  Given a list of possible Spelling Corrections for multiple mis-spelled words in a query, This iterator returns Possible Correction combinations ordered by reasonable probability that such a combination will return actual hits if re-queried. This implementation simply ranks the Possible Combinations by the sum of their component ranks.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `PossibilityIterator.RankedSpellPossibility`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PossibilityIterator(Map<Token,LinkedHashMap<String,Integer>> suggestions, int maximumRequiredSuggestions, int maxEvaluations, boolean overlap)` We assume here that the passed-in inner LinkedHashMaps are already sorted in order of "Best Possible Correction".

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `hasNext()`
    `PossibilityIterator.RankedSpellPossibility` | `next()`
    `void` | `remove()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Constructor Detail

    - #### PossibilityIterator

          public PossibilityIterator(Map<Token,LinkedHashMap<String,Integer>> suggestions,
                                     int maximumRequiredSuggestions,
                                     int maxEvaluations,
                                     boolean overlap)

      We assume here that the passed-in inner LinkedHashMaps are already sorted in order of "Best Possible Correction".

  - ### Method Detail

    - #### hasNext

          public boolean hasNext()

      Specified by:
        `hasNext` in interface `Iterator<PossibilityIterator.RankedSpellPossibility>`

    - #### next

          public PossibilityIterator.RankedSpellPossibility next()

      Specified by:
        `next` in interface `Iterator<PossibilityIterator.RankedSpellPossibility>`

    - #### remove

          public void remove()

      Specified by:
        `remove` in interface `Iterator<PossibilityIterator.RankedSpellPossibility>`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.